package cn.com.tenlion.institutionmanagement.service.institution;

import cn.com.tenlion.institutionmanagement.pojo.bos.institution.InstitutionBO;
import cn.com.tenlion.institutionmanagement.pojo.dtos.institution.InstitutionDTO;
import cn.com.tenlion.institutionmanagement.pojo.pos.institution.InstitutionPO;
import cn.com.tenlion.institutionmanagement.pojo.vos.institution.InstitutionVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;


import java.util.List;
import java.util.Map;

/**
 * @ClassName: IInstitutionService
 * @Description: 机构管理
 * @Author: CodeFactory
 * @Date: 2021-04-28 17:58:49
 * @Version: 3.0
 **/
public interface IInstitutionService {

    /**
     * 新增机构管理
     *
     * @param institutionVO
     * @return
     */
    void save(InstitutionVO institutionVO);

    /**
     * 新增机构管理
     *
     * @param token
     * @param institutionVO
     * @return
     */
    void save(String token, InstitutionVO institutionVO);

    /**
     * 新增机构管理
     *
     * @param institutionVO
     * @return institutionId
     */
    String saveReturnId(InstitutionVO institutionVO);

    /**
     * 新增机构管理
     *
     * @param token
     * @param institutionVO
     * @return institutionId
     */
    String saveReturnId(String token, InstitutionVO institutionVO);

    /**
     * 删除机构管理
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除机构管理
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除机构管理（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改机构管理
     *
     * @param institutionId
     * @param institutionVO
     * @return
     */
    void update(String institutionId, InstitutionVO institutionVO);

    /**
     * 修改机构管理
     *
     * @param token
     * @param institutionId
     * @param institutionVO
     * @return
     */
    void update(String token, String institutionId, InstitutionVO institutionVO);

    /**
     * 机构管理详情
     *
     * @param params 参数Map
     * @return
     */
    InstitutionDTO get(Map<String, Object> params);

    /**
     * 机构管理详情
     *
     * @param institutionId
     * @return
     */
    InstitutionDTO get(String institutionId);

    /**
     * 机构管理详情
     *
     * @param params 参数Map
     * @return
     */
    InstitutionBO getBO(Map<String, Object> params);

    /**
     * 机构管理详情
     *
     * @param institutionId
     * @return
     */
    InstitutionBO getBO(String institutionId);

    /**
     * 机构管理详情
     *
     * @param params 参数Map
     * @return
     */
    InstitutionPO getPO(Map<String, Object> params);

    /**
     * 机构管理详情
     *
     * @param institutionId
     * @return
     */
    InstitutionPO getPO(String institutionId);

    /**
     * 机构管理列表
     *
     * @param params
     * @return
     */
    List<InstitutionDTO> list(Map<String, Object> params);

    /**
     * 机构管理列表
     *
     * @param params
     * @return
     */
    List<InstitutionBO> listBO(Map<String, Object> params);

    /**
     * 机构管理列表
     *
     * @param params
     * @return
     */
    List<InstitutionPO> listPO(Map<String, Object> params);

    /**
     * 机构管理分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<InstitutionDTO>> listPage(ListPage page);

    /**
     * 机构管理统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}